Kaynağa Gözat

adding php files for accessing the service from a website.

Klaas, Wilfried 4 yıl önce
ebeveyn
işleme
da693be2e2

+ 81 - 0
spsassembler/Dockerfile

@@ -0,0 +1,81 @@
+##### BUILDER #####
+
+FROM alpine:3.11 as builder
+
+## Task: artifacts, tools and configs
+
+COPY ./target/spsassembler.jar /service/spsassembler.jar
+COPY ./content/ /
+
+## Task: filesystem permissions
+RUN set -eux; \
+    chown -R 0.0 /config \
+                 /service; \
+    chmod 0777 /*.sh \
+               /config \
+               /service; \
+    chmod 0666 /config/* \
+               /service/*
+
+## Task: runtime dependencies
+
+# hadolint ignore=DL3018
+RUN set -eux; \
+    apk add --no-progress --quiet --no-cache --upgrade --virtual .run-deps \
+        tzdata
+
+# hadolint ignore=DL3018,SC2183,DL4006
+RUN set -eu +x; \
+    apk add --no-progress --quiet --no-cache --upgrade ncurses; \
+    apk update --quiet; \
+    printf '%30s\n' | tr ' ' -; \
+    echo "RUNTIME DEPENDENCIES"; \
+    PKGNAME=$(apk info --depends .run-deps \
+        | sed '/^$/d;/depends/d' \
+        | sort -u ); \
+    printf '%s\n' "${PKGNAME}" \
+        | while IFS= read -r pkg; do \
+                apk info --quiet --description --no-network "${pkg}" \
+                | sed -n '/description/p' \
+                | sed -r "s/($(echo "${pkg}" | sed -r 's/\+/\\+/g'))-(.*)\s.*/\1=\2/"; \
+                done \
+        | tee -a /usr/share/rundeps; \
+    printf '%30s\n' | tr ' ' - 
+
+
+
+##### TARGET #####
+
+FROM adoptopenjdk/openjdk14:alpine-slim
+
+ARG IMG_VERSION
+
+ENV IMG_VERSION="${IMG_VERSION}" \
+    CLASSPATH=".:/service/*" \
+    CONFIGFILE="config/config.yaml" \
+    JAVA_OPTS="-XX:+ExitOnOutOfMemoryError -XshowSettings:vm -XX:-UsePerfData -XX:NativeMemoryTracking=summary"
+
+COPY --from=builder /*.sh /
+COPY --from=builder /config /config
+COPY --from=builder /service /service
+COPY --from=builder /usr/share/rundeps /usr/share/rundeps
+
+RUN set -eux; \
+    xargs -a /usr/share/rundeps apk add --no-progress --quiet --no-cache --upgrade --virtual .run-deps; \
+    mkdir -m 0777 /opt/data
+
+EXPOSE 8080 8081
+
+HEALTHCHECK --interval=30s --timeout=5s --retries=3 --start-period=10s \
+  CMD wget -q -T 5 --spider --no-check-certificate http://localhost:8081/healthcheck
+
+ENTRYPOINT ["/entrypoint.sh"]
+
+LABEL org.opencontainers.image.title="SPSAssembler" \
+      org.opencontainers.image.description="SPSAssembler" \
+      org.opencontainers.image.version="${IMG_VERSION}" \
+      org.opencontainers.image.source="https://wkla.no-ip.biz/gogs/Willie/SPS_Emulator_Java.git" \
+      org.opencontainers.image.vendor="MCS" \
+      org.opencontainers.image.authors="wkla" \
+      maintainer="MCS" \
+      NAME="SPSAssembler"

+ 5 - 0
spsassembler/buildDocker.cmd

@@ -0,0 +1,5 @@
+docker image build -t spsassembler:1.0 -t spsassembler:latest .
+docker run --restart=always -d -p8180:8080 -p8181:8081 --name spsassembler spsassembler
+docker save -o="spsassembler.tar" spsassembler
+copy spsassembler.tar \\192.168.178.14\Docker\dockerbuild\spsassembler\
+del spsassembler.tar 

+ 1 - 0
spsassembler/content/config/config.yaml

@@ -0,0 +1 @@
+name: "Hallo"

+ 36 - 0
spsassembler/content/entrypoint.sh

@@ -0,0 +1,36 @@
+#!/bin/sh
+set -e
+
+# memory
+export JAVA_OPTS="${JAVA_OPTS} -Xms${JAVA_XMS:-256M} -XX:MaxRAMPercentage=${JAVA_MAXRAMPERC:-70.0}"
+
+# Jmxremote
+if [ "${JAVA_JMXREMOTE}" = "true" ]; then
+  export JAVA_OPTS="${JAVA_OPTS} -Dcom.sun.management.jmxremote.authenticate=false -Dcom.sun.management.jmxremote.ssl=false -Dcom.sun.management.jmxremote.port=1099"
+  echo "[$(date -R)] [ENTRYPOINT] Enable jmxremote"
+fi
+
+# terminate handler
+sigterm_handler() {
+  PID=$(pidof java)
+  echo "[$(date -R)] [ENTRYPOINT] Received shutdown signal at $(date), forwarding to PID: ${PID}"
+  if [ "${PID}" -ne 0 ]; then
+    kill "${PID}"
+  fi
+}
+
+# if we receive SIGTERM (from docker stop) or SIGINT (ctrl+c if not running as daemon)
+# trap the signal and delegate to sigterm_handler function, which will notify hazelcast instance process
+trap sigterm_handler TERM INT
+
+# shellcheck disable=SC2086
+java ${JAVA_OPTS} -jar /service/spsassembler.jar server "${CONFIGFILE}" &
+PID="$!"
+echo "[$(date -R)] [ENTRYPOINT] Starting service with process id: ${PID}"
+echo ""
+
+# wait on hazelcast instance process
+wait "${PID}"
+# if a signal came up, remove previous traps on signals and wait again (noop if process stopped already)
+trap - TERM INT
+wait "${PID}"

+ 1 - 14
spsassembler/pom.xml

@@ -79,6 +79,7 @@
 				<artifactId>maven-jar-plugin</artifactId>
 				<version>2.6</version>
 				<configuration>
+					<finalName>${project.artifactId}</finalName>
 					<archive>
 						<manifest>
 							<mainClass>de.mcs.tools.sps.SPSAssembler</mainClass>
@@ -134,20 +135,6 @@
 					</execution>
 				</executions>
 			</plugin>
-			<!-- <plugin> <groupId>com.akathist.maven.plugins.launch4j</groupId> <artifactId>launch4j-maven-plugin</artifactId> 
-				<version>1.7.24</version> <executions> <execution> <id>l4j-clui</id> <phase>package</phase> 
-				<goals> <goal>launch4j</goal> </goals> <configuration> <dontWrapJar>false</dontWrapJar> 
-				<headerType>console</headerType> <jar>${project.build.directory}/${project.artifactId}-${project.version}.jar</jar> 
-				<outfile>${project.build.directory}/MCSSPSTools.exe</outfile> <downloadUrl>http://java.com/download</downloadUrl> 
-				<classPath> <mainClass>com.howtodoinjava.ApplicationMain</mainClass> <preCp>anything</preCp> 
-				</classPath> <icon>src\main\resources\MSA.ico</icon> <jre> <path>/jre</path> 
-				<minVersion>1.8.0</minVersion> <jdkPreference>jreOnly</jdkPreference> </jre> 
-				<versionInfo> <fileVersion>1.0.0.0</fileVersion> <txtFileVersion>${project.version}</txtFileVersion> 
-				<fileDescription>${project.name}</fileDescription> <copyright>2018 MCS</copyright> 
-				<productVersion>1.0.0.0</productVersion> <txtProductVersion>1.0.0.0</txtProductVersion> 
-				<productName>${project.name}</productName> <companyName>MCS</companyName> 
-				<internalName>MCSSPSTools</internalName> <originalFilename>MCSSPSTools.exe</originalFilename> 
-				</versionInfo> </configuration> </execution> </executions> </plugin> -->
 		</plugins>
 	</build>
 	<dependencies>

+ 13 - 0
spsassembler/src/main/java/de/mcs/tools/sps/service/AsmConfiguration.java

@@ -3,6 +3,8 @@
  */
 package de.mcs.tools.sps.service;
 
+import com.fasterxml.jackson.annotation.JsonProperty;
+
 import io.dropwizard.Configuration;
 
 /**
@@ -11,4 +13,15 @@ import io.dropwizard.Configuration;
  */
 public class AsmConfiguration extends Configuration {
 
+  @JsonProperty
+  private String name;
+
+  public String getName() {
+    return name;
+  }
+
+  public void setName(String name) {
+    this.name = name;
+  }
+
 }

+ 56 - 0
spsassembler/src/main/java/de/mcs/utils/JacksonUtils.java

@@ -0,0 +1,56 @@
+package de.mcs.utils;
+/**
+ * 
+ */
+
+import com.fasterxml.jackson.annotation.JsonInclude.Include;
+import com.fasterxml.jackson.annotation.JsonProperty;
+import com.fasterxml.jackson.core.JsonProcessingException;
+import com.fasterxml.jackson.databind.DeserializationFeature;
+import com.fasterxml.jackson.databind.ObjectMapper;
+import com.fasterxml.jackson.databind.SerializationFeature;
+import com.fasterxml.jackson.dataformat.yaml.YAMLFactory;
+
+/**
+ * @author wklaa_000
+ *
+ */
+public class JacksonUtils {
+
+  private static ObjectMapper ymlObjectMapper;
+
+  public static ObjectMapper getYmlMapper() {
+    if (ymlObjectMapper == null) {
+      ymlObjectMapper = new ObjectMapper(new YAMLFactory());
+      ymlObjectMapper.configure(DeserializationFeature.FAIL_ON_UNKNOWN_PROPERTIES, false);
+      ymlObjectMapper.configure(SerializationFeature.WRITE_NULL_MAP_VALUES, false);
+      ymlObjectMapper.setSerializationInclusion(Include.NON_NULL);
+    }
+    return ymlObjectMapper;
+  }
+
+  private static ObjectMapper jsonObjectMapper;
+
+  public static ObjectMapper getJsonMapper() {
+    if (jsonObjectMapper == null) {
+      jsonObjectMapper = new ObjectMapper();
+      jsonObjectMapper.configure(DeserializationFeature.FAIL_ON_UNKNOWN_PROPERTIES, false);
+      jsonObjectMapper.configure(SerializationFeature.WRITE_NULL_MAP_VALUES, false);
+      jsonObjectMapper.setSerializationInclusion(Include.NON_NULL);
+    }
+    return jsonObjectMapper;
+  }
+
+  private static class StringMessage {
+    @JsonProperty
+    private String message;
+
+    public StringMessage(String message) {
+      this.message = message;
+    }
+  }
+
+  public static String messageToJson(String message) throws JsonProcessingException {
+    return getJsonMapper().writeValueAsString(new StringMessage(message));
+  }
+}

+ 53 - 0
spsassembler/src/main/php/ass.php

@@ -0,0 +1,53 @@
+<?php
+
+$source = $_POST["source"];
+$filename = $_POST["name"];
+$name = pathinfo($filename, PATHINFO_FILENAME);
+$url = "http://192.168.178.14:8180/assemble";
+
+$source = str_replace("\r", "", $source);
+$source = str_replace("\n", "\\n", $source);
+
+$content = "{\"name\":\"$filename\",\"hardware\":\"arduinosps\",\"content\":\"$source\"}";
+
+$data = $content;
+
+$headers = [
+	"Content-Type: application/json",
+	"X-Content-Type-Options:nosniff",
+	"Accept:application/json",
+	"Cache-Control:no-cache"
+];
+
+$client = curl_init($url);
+curl_setopt($client, CURLOPT_POST, 1);
+curl_setopt($client,CURLOPT_CUSTOMREQUEST, "POST");
+curl_setopt($client,CURLOPT_RETURNTRANSFER,true);
+curl_setopt($client, CURLOPT_POSTFIELDS, $data);
+curl_setopt($client,CURLOPT_HTTPHEADER, $headers);
+
+$response = curl_exec($client);
+$info = curl_getinfo($client);
+$code = $info["http_code"];
+$result = json_decode($response);
+
+if ($code == 200) {
+
+	header('Content-Type: text/simple');
+	header("Content-Disposition: attachment; filename=\"$name.hex\"");
+
+	echo $result->hexfile;
+} else {
+	$message = $result->message;
+	echo '<html><body>' . PHP_EOL;
+	echo 'processing failed. <br/>' . PHP_EOL;
+	echo "error code: $code<br/>" . PHP_EOL;
+	echo "message: $message <br/>" . PHP_EOL;
+	echo '</body></html>' . PHP_EOL;	
+}
+
+
+curl_close($client);
+
+
+?>

+ 68 - 0
spsassembler/src/main/php/css/jquery-linedtextarea.css

@@ -0,0 +1,68 @@
+/**
+ * jQuery Lined Textarea Plugin
+ *   http://alan.blog-city.com/jquerylinedtextarea.htm
+ *
+ * Copyright (c) 2010 Alan Williamson
+ *
+ * Released under the MIT License:
+ * http://www.opensource.org/licenses/mit-license.php
+ * 
+ * Usage:
+ *   Displays a line number count column to the left of the textarea
+ *   
+ *   Class up your textarea with a given class, or target it directly
+ *   with JQuery Selectors
+ *   
+ *   $(".lined").linedtextarea({
+ *   	selectedLine: 10,
+ *    selectedClass: 'lineselect'
+ *   });
+ *
+ */
+
+.linedwrap {
+	border: 1px solid #c0c0c0;
+	padding: 3px;
+}
+
+.linedtextarea {
+	padding: 0px;
+	margin: 0px;
+}
+
+.linedtextarea textarea, .linedwrap .codelines .lineno {
+	font-size: 10pt;
+	font-family: monospace;
+	line-height: normal !important;
+}
+
+.linedtextarea textarea {
+	padding-right:0.3em;
+	padding-top:0.3em;
+	border: 0;
+}
+
+.linedwrap .lines {
+	margin-top: 0px;
+	width: 50px;
+	float: left;
+	overflow: hidden;
+	border-right: 1px solid #c0c0c0;
+	margin-right: 10px;
+}
+
+.linedwrap .codelines {
+	padding-top: 5px;
+}
+
+.linedwrap .codelines .lineno {
+	color:#AAAAAA;
+	padding-right: 0.5em;
+	padding-top: 0.0em;
+	text-align: right;
+	white-space: nowrap;
+}
+
+.linedwrap .codelines .lineselect {
+	color: red;
+}

+ 37 - 0
spsassembler/src/main/php/examples/Blink.tps

@@ -0,0 +1,37 @@
+.macro blink
+PORT #0B0101
+WAIT 200ms
+PORT #0B1010
+WAIT 200ms
+.endmacro
+
+:loop
+.blink
+RJMP :loop
+/* 
+Kommentar über mehrere Zeilen
+*/
+
+.macro macro1 output time
+PORT output
+WAIT time
+PORT #0x00
+WAIT time
+.endmacro
+
+.include macro_blink
+:loop1
+.macro1 #0x0f 200ms
+
+PORT #0x0F ;Zeilenkommentar
+WAIT 200ms
+PORT #0x00
+WAIT 200ms
+RJMP :loop1
+
+DFSB 1
+PORT #0x0F ;Zeilenkommentar
+WAIT 200ms
+PORT #0x00
+WAIT 200ms
+RTR

+ 6 - 0
spsassembler/src/main/php/examples/Blink2.tps

@@ -0,0 +1,6 @@
+:loop
+PORT #0x0F
+WAIT 200ms
+PORT #0x00
+WAIT 200ms
+RJMP :loop

+ 32 - 0
spsassembler/src/main/php/examples/BlinkKomment.tps

@@ -0,0 +1,32 @@
+LDA #6
+MOV C,A
+:loop
+NOP
+NOP
+NOP
+NOP
+NOP
+PORT #0x0F
+WAIT 200ms
+PORT #0x00
+WAIT 200ms
+NOP
+PAGE :?
+CALL :loop3
+NOP
+NOP
+NOP
+PAGE :?
+LOOPC :loop
+NOP
+NOP
+:loop2
+PORT #0x0F
+:loop3
+PORT #0x00
+NOP
+NOP
+NOP
+PAGE :?
+LOOPD :loop2
+NOP

+ 20 - 0
spsassembler/src/main/php/examples/Blink_LOOP.tps

@@ -0,0 +1,20 @@
+PAGE :?
+JMP :loop2
+:loop
+NOP
+NOP
+NOP
+NOP
+NOP
+PORT #0x0F
+WAIT 200ms
+PORT #0x00
+WAIT 200ms
+NOP
+NOP
+NOP
+NOP
+:loop2
+RJMP :loop
+NOP
+NOP

+ 78 - 0
spsassembler/src/main/php/index.php

@@ -0,0 +1,78 @@
+<html>
+	<head>
+		<link href="css/jquery-linedtextarea.css" rel="stylesheet">
+		<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
+		<script src="js/jquery-linedtextarea.js"></script>
+	</head>
+	<body>
+		<?php
+		error_reporting(E_ALL & ~E_NOTICE);
+		$path = realpath(dirname("."));
+		if (isset($_FILES['srcfile']) && $_FILES['srcfile']['error'] === UPLOAD_ERR_OK) {
+			$folder = $_FILES['srcfile']['tmp_name'] ;
+			$file = $_FILES['srcfile']['name'];
+			echo "folder: $folder<br/>";
+			echo "filename: $file<br/>";
+			if (isset($file)) {
+				$source = file_get_contents($folder);
+				$source = str_replace("\r", "", $source);
+				$source = str_replace("\n", "\\n", $source);
+				unlink ($file);
+			}
+		}
+		$example = $_POST["examples"];
+		if (isset($example)) {
+			$files = glob($path."/examples/*.tps");
+			foreach($files as $filename){
+				if(is_file($filename)){
+					$basename = basename($filename);
+					if ($basename == $example) {
+						$source = file_get_contents($filename);
+						$source = str_replace("\r", "", $source);
+						$source = str_replace("\n", "\\n", $source);
+						$file = $basename;
+					}
+				}
+			}
+		}
+		?>
+		<form  method="post" enctype="multipart/form-data">
+			<input type="file" name="srcfile"/>
+			<button type="submit">load</button> 
+		</form>
+		<form  method="post">
+			<label for="examples">Examples:</label>
+			<select id="examples" name="examples" size="1">
+				<?php 
+				$files = glob($path."/examples/*.tps");
+				foreach($files as $filename){
+					if(is_file($filename)){
+						$basename = basename($filename);
+						echo "<option value=\"$basename\">$basename</option>\r\n"; 
+					}   
+				}
+				?>
+			</select>
+			<button type="submit">load</button> 
+		</form>
+		<form  method="post" action="ass.php" target="_blank">
+			Name: <input id="name" name="name">
+			<textarea class="lined" rows="10" cols="60" name="source"></textarea>
+			<button type="submit">Assemble</button> 
+		</form>
+
+		<script>
+			$(document).ready(function(){
+				$(".lined").linedtextarea();
+				<?php 
+				if (isset($source)) {
+					echo "\$(\".lined\").val(\"$source\");\r\n"; 
+				}
+				if (isset($file)) {
+					echo "\$(\"#name\").val(\"$file\");\r\n";
+				}
+				?>
+			});
+		</script>
+	</body>
+</html>

+ 126 - 0
spsassembler/src/main/php/js/jquery-linedtextarea.js

@@ -0,0 +1,126 @@
+/**
+ * jQuery Lined Textarea Plugin 
+ *   http://alan.blog-city.com/jquerylinedtextarea.htm
+ *
+ * Copyright (c) 2010 Alan Williamson
+ * 
+ * Version: 
+ *    $Id: jquery-linedtextarea.js 464 2010-01-08 10:36:33Z alan $
+ *
+ * Released under the MIT License:
+ *    http://www.opensource.org/licenses/mit-license.php
+ * 
+ * Usage:
+ *   Displays a line number count column to the left of the textarea
+ *   
+ *   Class up your textarea with a given class, or target it directly
+ *   with JQuery Selectors
+ *   
+ *   $(".lined").linedtextarea({
+ *   	selectedLine: 10,
+ *    selectedClass: 'lineselect'
+ *   });
+ *
+ * History:
+ *   - 2010.01.08: Fixed a Google Chrome layout problem
+ *   - 2010.01.07: Refactored code for speed/readability; Fixed horizontal sizing
+ *   - 2010.01.06: Initial Release
+ *
+ */
+(function($) {
+
+	$.fn.linedtextarea = function(options) {
+		
+		// Get the Options
+		var opts = $.extend({}, $.fn.linedtextarea.defaults, options);
+		
+		
+		/*
+		 * Helper function to make sure the line numbers are always
+		 * kept up to the current system
+		 */
+		var fillOutLines = function(codeLines, h, lineNo){
+			while ( (codeLines.height() - h ) <= 0 ){
+				if ( lineNo == opts.selectedLine )
+					codeLines.append("<div class='lineno lineselect'>" + lineNo + "</div>");
+				else
+					codeLines.append("<div class='lineno'>" + lineNo + "</div>");
+				
+				lineNo++;
+			}
+			return lineNo;
+		};
+		
+		
+		/*
+		 * Iterate through each of the elements are to be applied to
+		 */
+		return this.each(function() {
+			var lineNo = 1;
+			var textarea = $(this);
+			
+			/* Turn off the wrapping of as we don't want to screw up the line numbers */
+			textarea.attr("wrap", "off");
+			textarea.css({resize:'none'});
+			var originalTextAreaWidth	= textarea.outerWidth();
+
+			/* Wrap the text area in the elements we need */
+			textarea.wrap("<div class='linedtextarea'></div>");
+			var linedTextAreaDiv	= textarea.parent().wrap("<div class='linedwrap' style='width:" + originalTextAreaWidth + "px'></div>");
+			var linedWrapDiv 			= linedTextAreaDiv.parent();
+			
+			linedWrapDiv.prepend("<div class='lines' style='width:50px'></div>");
+			
+			var linesDiv	= linedWrapDiv.find(".lines");
+			linesDiv.height( textarea.height() + 6 );
+			
+			
+			/* Draw the number bar; filling it out where necessary */
+			linesDiv.append( "<div class='codelines'></div>" );
+			var codeLinesDiv	= linesDiv.find(".codelines");
+			lineNo = fillOutLines( codeLinesDiv, linesDiv.height(), 1 );
+
+			/* Move the textarea to the selected line */ 
+			if ( opts.selectedLine != -1 && !isNaN(opts.selectedLine) ){
+				var fontSize = parseInt( textarea.height() / (lineNo-2) );
+				var position = parseInt( fontSize * opts.selectedLine ) - (textarea.height()/2);
+				textarea[0].scrollTop = position;
+			}
+
+			
+			/* Set the width */
+			var sidebarWidth					= linesDiv.outerWidth();
+			var paddingHorizontal 		= parseInt( linedWrapDiv.css("border-left-width") ) + parseInt( linedWrapDiv.css("border-right-width") ) + parseInt( linedWrapDiv.css("padding-left") ) + parseInt( linedWrapDiv.css("padding-right") );
+			var linedWrapDivNewWidth 	= originalTextAreaWidth - paddingHorizontal;
+			var textareaNewWidth			= originalTextAreaWidth - sidebarWidth - paddingHorizontal - 20;
+
+			textarea.width( textareaNewWidth );
+			linedWrapDiv.width( linedWrapDivNewWidth );
+			
+
+			
+			/* React to the scroll event */
+			textarea.scroll( function(tn){
+				var domTextArea		= $(this)[0];
+				var scrollTop 		= domTextArea.scrollTop;
+				var clientHeight 	= domTextArea.clientHeight;
+				codeLinesDiv.css( {'margin-top': (-1*scrollTop) + "px"} );
+				lineNo = fillOutLines( codeLinesDiv, scrollTop + clientHeight, lineNo );
+			});
+
+
+			/* Should the textarea get resized outside of our control */
+			textarea.resize( function(tn){
+				var domTextArea	= $(this)[0];
+				linesDiv.height( domTextArea.clientHeight + 6 );
+			});
+
+		});
+	};
+
+  // default options
+  $.fn.linedtextarea.defaults = {
+  	selectedLine: -1,
+  	selectedClass: 'lineselect'
+  };
+})(jQuery);

+ 19 - 0
spsassembler/src/test/java/de/mcs/tools/sps/service/TestConfig.java

@@ -0,0 +1,19 @@
+package de.mcs.tools.sps.service;
+
+import org.junit.jupiter.api.Test;
+
+import com.fasterxml.jackson.core.JsonProcessingException;
+import com.fasterxml.jackson.databind.ObjectMapper;
+
+import de.mcs.utils.JacksonUtils;
+
+class TestConfig {
+
+  @Test
+  void test() throws JsonProcessingException {
+    AsmConfiguration config = new AsmConfiguration();
+    ObjectMapper ymlMapper = JacksonUtils.getYmlMapper();
+    System.out.println(ymlMapper.writeValueAsString(config));
+  }
+
+}